Page MenuHomePhabricator

Define the navigation elements of the Web APIs hub
Open, NormalPublic

Description

Our current prototype is embedded in mediawiki.org's navigation elements, but this is not how the Web APIs Hub is supposed to work in reality. However, how should this navigation work in reality?

In T301#1025618, @Spage wrote:

The "developer hub" skin needs

  • left-hand nav
  • support for in-page TOC
  • links to "divisions" across the top
  • Left-hand nav is supposed to substitute mediawiki.org's left hand nav, right? Which elements will it contain?
  • In-page TOC, ok.
  • "Divisions", are these tabs? In any case, which divisions will we have?

Related Objects

StatusAssignedTask
ResolvedQgil
ResolvedQgil
ResolvedQgil
Resolved Spage
OpenNone
Resolved Spage
Resolved Spage
Resolved Spage
OpenNone
OpenNone
ResolvedNone
OpenNone
ResolvedAnomie
OpenNone
OpenNone
OpenNone
Resolved Spage
Resolvedori
Resolvedjeropbrenda
OpenNone
DeclinedQgil
Resolved Spage
Resolved Spage
OpenNone
Resolved Spage

Event Timeline

Qgil created this task.Mar 18 2015, 1:10 PM
Qgil raised the priority of this task from to Normal.
Qgil updated the task description. (Show Details)
Qgil added projects: ECT-March-2015, Web-APIs-Hub.
Qgil added subscribers: waldyrious, Spage, revi, Qgil.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 18 2015, 1:10 PM
Dzahn added a subscriber: Dzahn.Jun 24 2015, 5:48 PM

You can change Mediawiki's left-hand nav by editing MediawikI:Sidebar et al.

https://www.mediawiki.org/wiki/Manual:Interface/Sidebar

You can insert a TOC anywhere with magic word TOC

https://www.mediawiki.org/wiki/Manual%3aTable_of_contents#Positioning_the_TOC

You can add new "divisions" (tabs) like here:

https://www.mediawiki.org/wiki/Manual:FAQ#How_do_I_add.2Fremove_tabs_throughout_my_wiki.3F

Qgil added a comment.Jun 24 2015, 8:50 PM

Is that true in Blueprint skin?

Dzahn added a comment.Jun 24 2015, 9:18 PM

I _think_ these things should not change depending on which skin you are using.

Qgil renamed this task from Define the navigation elements of dev.wikimedia.org to Define the navigation elements of the Web APIs hub.Aug 4 2015, 10:23 AM
Qgil updated the task description. (Show Details)

@Qgil, maybe we don't need tabs for "divisions"; that was me looking at some mockups from Jared Zimmerman that linked doc.wikimedia.org, dev.wikimedia.org, and mediawiki.org.

Is that [@Dzahn's explanation] true in Blueprint skin?

Blueprint works differently than other skins:

  • It has its own 'MediaWiki:Blueprint-left-nav' (sample) definition for its pop-up sidebar.
  • It removes the current page's TOC and inserts it into its pop-up sidebar, under the current page in the left-nav links, or at the bottom of the sidebar if the current page is not one of the left-nav links.

Blueprint currently works best when the left nav isn't too big and all pages are links in it. That won't apply for the API namespace. So we could continue to have in-page navigation for the PHP action API, or we could come up with requirements for a better Blueprint.

Qgil added a comment.Aug 10 2015, 9:57 AM

With only paper and pencil (or with only a textarea in this task), what is the navigation structure we need to organize all the API: namespace content, old and new? Let's solve this question first, and then we will see how can we use Blueprint and on-wiki navigation templates.

Spage moved this task from Backlog to Ready to Go on the ECT-August-2015 board.Sep 1 2015, 4:16 PM

Update: I've refined the big unwieldy API navigation template to reference Web APIs hub before its big list of action API pages. I think it's OK for the Web APIs showcase pages to not have that big navigation that's mostly dedicated to the action API.

The Web APIs hub pages in Blueprint have their own navigation in the Blueprint sidebar (sample - click the top left icon). We need to decide whether to replicate this in non-Blueprint skins or push for Blueprint.

I added the {{API}} navigation template to Web APIs hub "Build" section, but collapsed. Ugly, but it adds navigation to the new front door that developers requested. A next step would be a gadget to "jump down to navigation", and/or perhaps shrink it to just
[Show action API navigation]

I added a proposal to improve the API navigation to its talk page, basically making it a proper menu bar like:

MediaWiki APIs ▼: action API ▼ | RESTBase ▼ | Wikidata Query Service ▼
Aklapper removed Spage as the assignee of this task.Sep 23 2016, 2:11 PM